#include "EveryTimerB.h"
#include <Adafruit_NeoPixel.h>

#define Timer1 TimerB2    // use TimerB2 as a drop in replacement for Timer1

#define NP_H  4
#define NP_L  5
#define NP_R  6
#define DRUM  7
#define RESET 8

#define NUMSTICK 10
#define NUMHEART 17

Adafruit_NeoPixel pixels_H(NUMHEART, NP_H, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel pixels_L(NUMSTICK, NP_L, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel pixels_R(NUMSTICK, NP_R, NEO_GRB + NEO_KHZ800);

String inputString = "";
String bufString = "";

byte reg[6] = {0};
unsigned long cnt = 0;

void setup() {
  pixels_H.begin();
  pixels_L.begin();
  pixels_R.begin();

  pinMode(NP_H, OUTPUT);
  pinMode(NP_L, OUTPUT);
  pinMode(NP_R, OUTPUT);
  pinMode(DRUM, OUTPUT);
  pinMode(RESET, OUTPUT);
  digitalWrite(DRUM, LOW);
  digitalWrite(RESET, LOW);

  Serial.begin(19200);
  Serial1.begin(19200);
  inputString.reserve(200);
  bufString.reserve(10);
  
  delay(500);
  digitalWrite(RESET, HIGH);

  pixels_H.setBrightness( 30 );
  pixels_L.setBrightness( 30 );
  pixels_R.setBrightness( 30 );
  pixels_H.clear();

  Timer1.initialize();
  Timer1.attachInterrupt( timer_10ms );
  Timer1.setPeriod( 10000 );
}

void loop() {
  pixels_L.clear();
  pixels_R.clear();

  if ( Serial1.available() > 0 ) {
    char inChar = Serial1.read();
    inputString += inChar;
    if (inChar == '\n') {
      INT_DETECTS();
      inputString = "";
      bufString = "";
    }
  }
}

void INT_DETECTS(void) {
  int dataindex;
  char **e;

  dataindex = inputString.indexOf(':') + 1;
  bufString = inputString.substring(dataindex, (dataindex + 2));
  const char *s = bufString.c_str();
  reg[0] = (byte)strtol(s, e, 16);
  for( int i=1 ; i < sizeof(reg) ; i++ ) {
    dataindex = inputString.indexOf(',', dataindex) + 1;
    bufString = inputString.substring(dataindex, (dataindex + 2));
    const char *s = bufString.c_str();
    reg[i] = (byte)strtol(s, e, 16);
  }

  for ( int i=0 ; i < 6 ; i++ ) {
    Serial.print( reg[i], HEX );
    Serial.print( ", " );
  }
  Serial.println("");

  if ( reg[0] != 0 ) {
    cnt = 5;
  }

  for( int i=0 ; i < NUMHEART ; i++ ) {
    pixels_H.setPixelColor( i, pixels_H.Color( reg[1], reg[2], reg[3] ) );
  }

  for( int i=0 ; i < ( map( reg[4], 0, 255, 0, NUMSTICK-1 ) ) ; i++ ) {
    pixels_L.setPixelColor( i, pixels_L.Color( reg[1], reg[2], reg[3] ) );
  }

  for( int i=0 ; i < ( map( reg[5], 0, 255, 0, NUMSTICK-1 ) ) ; i++ ) {
    pixels_R.setPixelColor( i, pixels_R.Color( reg[1], reg[2], reg[3] ) );
  }

  pixels_H.show();
  pixels_L.show();
  pixels_R.show();
}

void timer_10ms() {
  if ( cnt > 0 ) {
    cnt--;
    digitalWrite( DRUM, HIGH );
  } else {
    cnt = 0;
    digitalWrite( DRUM, LOW );
  }
}
